#!/usr/bin/env python
# -*- coding: utf-8 -*-
'''
Copyright (C) 2008 Thomas Holder, http://sf.net/users/speleo3/
Distributed under the terms of the GNU General Public License v2

PROGRAMMING IN PROGRESS
'''

import sys, os, re
from StringIO import StringIO
from th2ex import *
etree = inkex.etree
import simplepath


# os.path.dirname(__file__)
template = file(os.path.join(sys.path[0], 'th2_template.svg'), 'r')
document = etree.parse(template)
template.close()

root = document.getroot()

ids = root.xpath('/svg/defs/*[starts-with(@id, "point-")]/@id')
point_symbols = [ id[6:] for id in ids ]

ids = root.xpath('/svg/defs/*[starts-with(@id, "LPE-")]/@id')
LPE_symbols = [ id[4:] for id in ids ]

currentlayer = root.xpath('g[@id="layer-legend"]')[0]
#sublayers = {}
#def getsub(key):
#	sublayers.get(key, currentlayer)

# points legend
spacing = 40
max_x = 800
x = spacing
y = 0 
for type in point_symbols:
	node = etree.SubElement(currentlayer, 'text')
	node.set('transform', 'translate(%d,%d)' % (x, -(y + 0.25) * spacing))
	node.text = type
	node = etree.SubElement(currentlayer, 'use')
	set_props(node, 'point', type)
	node.set('transform', 'translate(%d,%d)' % (x, -(y + 1) * spacing))
	node.set(xlink_href, '#point-' + type)
	x += spacing
	if x > max_x:
		x = spacing
		y += 2

node = etree.SubElement(currentlayer, 'rect', { 'style': 'fill:none;stroke:black', 'transform': 'scale(1,-1)'  })
node.set('height', '%d' % ((2 + y) * spacing))
if y > 0:
	node.set('width', '%d' % (max_x + spacing))
else:
	node.set('width', '%d' % (x))

default_line_opts = {
	'section': {'direction': 'begin'},
}

x = spacing
for type in LPE_symbols:
	type_uscore = type
	type = type.replace('_', ':')
	node = etree.SubElement(currentlayer, 'text')
	node.set('transform', 'translate(%d,%d)' % (-spacing, x + 0.4 * spacing))
	node.text = type
	node = etree.SubElement(currentlayer, 'path')
	set_props(node, 'line', type, default_line_opts.get(type, {}))
	node.set(inkscape_original_d, 'M%f,%fh%f' % (-1.5*spacing, x, spacing))
	node.set(inkscape_path_effect, '#LPE-' + type_uscore)
	node.set('class', 'line ' + type.replace(':', ' '))
	x += spacing
for type in ('arrow','map-connection','gradient','chimney','section'):
	node = etree.SubElement(currentlayer, 'text')
	node.set('transform', 'translate(%d,%d)' % (-spacing, x + 0.4 * spacing))
	node.text = type
	node = etree.SubElement(currentlayer, 'path')
	set_props(node, 'line', type, default_line_opts.get(type, {}))
	node.set('d', 'M%f,%fh%f' % (-1.5*spacing, x, spacing))
	node.set('class', 'line ' + type)
	x += spacing

node = etree.SubElement(currentlayer, 'rect', { 'y': '0', 'style': 'fill:none;stroke:black' })
node.set('x', '%d' % (-2 * spacing))
node.set('height', '%d' % (x))
node.set('width', '%d' % (2 * spacing))

# currentlayer = root
currentlayer = root.xpath('g[@id="layer-scrap0"]')[0]

# open th2 file
filename = sys.argv[-1]
f = file(filename, 'rU')

doc_x = 0
doc_y = 0
doc_width = 0
scrap_transform = ''
scrap_transform_inv = ''
encoding = 'UTF-8'

def flipY(a):
	for i in range(1, len(a), 2):
		a[i] = str(float(a[i]) * -1)
	return a

def reverseP(p):
	retval = []
	prevcmd = p[-1][0]
	prevparams = p[-1][1]
	retval = [['M', prevparams[-2:]]]
	for cmd,params in reversed(p[:-1]):
		newparams = []
		if len(prevparams) == 6:
			newparams = [
				prevparams[2],
				prevparams[3],
				prevparams[0],
				prevparams[1]
			]
		newparams.extend(params[-2:])
		retval.append([prevcmd, newparams])
		prevparams = params
		prevcmd = cmd
	return retval

def reverseD(d):
	p = simplepath.parsePath(d)
	p = reverseP(p)
	return simplepath.formatPath(p)

def f_readline():
	line = unicode(f.readline(), encoding)
	if line[-2:] == '\\\n':
		line = line[:-2] + f_readline()
	return line

def parse(a):
	function = parsedict.get(a[0])
	if function:
		function(a)
	else:
		sys.stderr.write('skipped: ' + a[0] + '\n')

def parse_encoding(a):
	global encoding
	encoding = a[1]

def parse_INKSCAPE(a):
	if a[1] == 'image':
		img = etree.Element('image')
		img.set('width', a[2])
		img.set('height', a[3])
		img.set('transform', a[4])
		img.set(xlink_href, ' '.join(a[5:]))
		root.xpath('g[@id="layer-scan"]')[0].append(img)

def parse_XTHERION(a):
	global doc_width, doc_x, doc_y
	global scrap_transform, scrap_transform_inv
	if a[1] == 'xth_me_image_insert':
		m = re.match(r'\{([-.0-9]+) [01] [-.0-9]+\} \{?([-.0-9]+)(?: \{\}\})? (\S+)', ' '.join(a[2:]))
		href = m.group(3)
		if href[0] == '"':
			href = href[1:-1]
		if m:
			img = etree.Element('image')
			img.set(xlink_href, href)
			img.set('x', m.group(1))
			img.set('y', str(-1 * float(m.group(2))))
			img.set('transform', 'scale(1,-1)')
			root.xpath('g[@id="layer-scan"]')[0].append(img)
		else:
			sys.stderr.write('skipped: ' + a[1] + '\n')

	if a[1] == 'xth_me_area_adjust':
		doc_x = float(a[2])
		doc_y = float(a[5])
		doc_width = float(a[4]) - doc_x
		doc_height = doc_y - float(a[3])
		scrap_transform = 'translate(%f,%f)' % (-doc_x, doc_y)
		scrap_transform_inv = 'translate(%f,%f)' % (doc_x, -doc_y)

		root.set('width', str(doc_width))
		root.set('height', str(doc_height))

def parse_scrap(a):
	e = etree.Element('g')
	e.set(inkscape_groupmode, "layer")
	e.set('transform', scrap_transform)
	
	# e.set(inkscape_label, ' '.join(a))
	e.set(inkscape_label, a[1])
	e.set(therion_role, 'scrap')
	e.set(therion_options, ' '.join(a[2:]))

#	global sublayers
#	sublayers = {
#		'labe': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Labels'}),
#		'stat': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Messpunkte'}),
#		'wall': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Wand'}),
#		'sign': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Signaturen'}),
#		'rock': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Steine'}),
#		'cont': etree.SubElement(e, 'g', {inkscape_groupmode: 'layer', inkscape_label: u'Abbrüche'}),
#	}

	root.append(e)
	global currentlayer
	currentlayer = e

	while True:
		line = f_readline()
		a = line.split()
		if len(a) == 0:
			continue
		if a[0] == 'endscrap':
			break
		parse(a)
	
	currentlayer = root

def parse_BLOCK2COMMENT(a):
	role = a[0]
	e = etree.Comment('#therion\n')
	e.text += ' '.join(a) + '\n'
	while True:
		line = f_readline()
		e.text += line
		a = line.split()
		if len(a) > 0 and a[0] == 'end%s' % (role):
			break
	currentlayer.insert(0, e)

def parse_LINE2COMMENT(a):
	e = etree.Comment('#therion\n')
	e.text += ' '.join(a) + '\n'
	currentlayer.insert(0, e)

textblock_count = 0

def parse_BLOCK2TEXT(a):
	global textblock_count
	role = a[0]
	e = etree.Element('text')
	if currentlayer != root:
		e.set('transform', scrap_transform_inv)
	e.set(therion_role, 'textblock')
	e.set('style', 'font-size:8;fill:#900')
	e.set('x', str(doc_width + 20))
	e.set('y', str(textblock_count * 10 + 20))
	e.set(xml_space, 'preserve')
	desc = etree.SubElement(e, 'desc')
	desc.tail = ' '.join(a)
	while True:
		line = f_readline()
		a = line.split()
		if len(a) > 0 and a[0] == 'end%s' % (role):
			break
		if desc.text == None:
			desc.text = line
		else:
			desc.text += line
	currentlayer.insert(0, e)
	textblock_count += 1

def parse_line(a):
	options = parse_options(a[2:])
	if ':' in a[1]:
		type, subtype = a[1].split(':', 1)
	else:
		type = a[1]
		subtype = options.get('subtype', '')

	e = etree.Element('path')
	set_props(e, 'line', a[1], options)
	e.set('class', 'line %s %s' % (type, subtype))

	insensitive = False
	lossless_repr = ''

	d = ""
	started = False
	while True:
		line = f_readline()
		a = line.split()
		if len(a) == 0:
			continue
		if a[0] == 'endline':
			break
		lossless_repr += line
		if a[0] == 'smooth':
			# ignore smooth option
			continue
		if a[0][0].isdigit() or a[0][0] == '-':
			if not started:
				d += 'M'
				started = True
			elif len(a) == 2:
				d += ' L'
			elif len(a) == 6:
				d += ' C'
			else:
				insensitive = True
				sys.stderr.write('error: length = ' + str(len(a)))
			d += ','.join(flipY(a))
		else:
			insensitive = True
			sys.stderr.write('skipped line option: ' + ' '.join(a) + '\n')

	if insensitive:
		sys.stderr.write('element not fully supported, will be read-only\n')
		e.set(sodipodi_insensitive, 'true')
		desc = etree.SubElement(e, 'desc')
		desc.text = lossless_repr
	
	if options.get('reverse', 'off') == 'on':
		d = reverseD(d)
		if not insensitive:
			del options['reverse']

	if options.get('close', 'off') == 'on':
		d += ' z'
		if not insensitive:
			del options['close']
	
	if type + '_' + subtype in LPE_symbols:
		e.set(inkscape_path_effect, '#LPE-%s_%s' % (type, subtype))
		e.set(inkscape_original_d, d)
	elif type in LPE_symbols:
		e.set(inkscape_path_effect, '#LPE-%s' % (type))
		e.set(inkscape_original_d, d)
	else:
		e.set('d', d)

	e.set(therion_options, format_options(options, False))
	currentlayer.insert(0, e)

align_shortcuts = {
	'center': 'c',
	'top': 't',
	'bottom': 'b',
	'left': 'l',
	'right': 'r',
	'top-left': 'tl',
	'top-right': 'tr',
	'bottom-left': 'bl',
	'bottom-right': 'br',
}

align_lossless = {
	'tr': 'start',
	't': 'middle',
	'tl': 'end',
}

align = {
	'c': 'middle',
	't': 'middle',
	'b': 'middle',
	'l': 'end',
	'r': 'start',
	'tl': 'end',
	'tr': 'start',
	'bl': 'end',
	'br': 'start',
}

# like 1:500
fontscale = {
	'xl': '17.435',
	'l': '12.435',
	'm': '9.963',
	's': '8.717',
	'xs': '7.472',
}

text_keys = {
	# 'station': 'name',

	'label': 'text',
	'remark': 'text',
	'station-name': 'text',
	# 'continuation': 'text',
	
	'dimensions': 'value',
	'height': 'value',
	'passage-height': 'value',
	'altitude': 'value',
	'date': 'value',
}

point_colors = {
	'station-name': 'orange',
	'altitude': '#f0f',
	'u': 'red',
}

def parse_point(a):
	options = parse_options(a[4:])
	type = a[3].split(':')[0]

	as_text = False
	if type in text_keys:
		key = text_keys[type]
		if options.has_key(key):
			as_text = True
	if as_text:
		e = etree.Element('text')
		y = 0
		for line in options[key].split('<br>'):
			t = etree.SubElement(e, 'tspan', { sodipodi_role: 'line', 'x': '0', 'y': '%dem' % (y) })
			t.text = line
			y += 1
		del options[key]
		if options.get('align') in align_shortcuts:
			options['align'] = align_shortcuts[options.get('align')]
		fontsize = fontscale.get(options.get('scale'), '12')
		textanchor = align.get(options.get('align', 'c'))
		if options.get('align') in align_lossless:
			del options['align']
		if 'scale' in options:
			del options['scale']
		e.set('style', "font-size:%s;text-anchor:%s" % (fontsize, textanchor))
		e.set(xml_space, 'preserve')
	elif type in point_symbols:
		e = etree.Element('use')
		e.set(xlink_href, "#point-" + type)
	else:
		e = etree.Element('circle')
		e.set('r', '2')
		if type in point_colors:
			e.set('style', 'fill:' + point_colors[type])

	# position and orientation
	transform = 'translate(%s,%f)' % (a[1], float(a[2]) * -1)
	if options.has_key('orientation'):
		transform += ' rotate(%s)' % (options['orientation'])
		del options['orientation']
	e.set('transform', transform)

	set_props(e, 'point', a[3], options)
	currentlayer.insert(0, e)

parsedict = {
	'##XTHERION##':	parse_XTHERION,
	'##INKSCAPE##':	parse_INKSCAPE,
	'scrap':		parse_scrap,
	'line':			parse_line,
	'point':		parse_point,
	'encoding':		parse_encoding,
	'area':			parse_BLOCK2COMMENT,
	'map':			parse_BLOCK2COMMENT,
	'centerline':	parse_BLOCK2COMMENT,
	'centreline':	parse_BLOCK2COMMENT,
	'input':		parse_LINE2COMMENT,
}

while True:
	line = f_readline()
	if len(line) == 0:
		break
	
	a = line.split()

	if len(a) == 0:
		continue
	
	parse(a)

e = root.xpath('g[@id="layer-scan"]')[0]
e.set('transform', scrap_transform + ' scale(1,-1)')

e = root.xpath('g[@id="layer-scrap0"]')[0]
if len(e) > 0:
	e.set('transform', scrap_transform)
else:
	root.remove(e)

document.write(sys.stdout)
