#!/usr/bin/python

from th2ex import *
import re

class Th2SetProps(inkex.Effect):
	def __init__(self):
		inkex.Effect.__init__(self)
		self.OptionParser.add_option("--role", type="string", dest="role", default="")
		self.OptionParser.add_option("--type", type="string", dest="type", default="")
		self.OptionParser.add_option("--options", type="string", dest="options", default="")
		self.OptionParser.add_option("--merge", type="inkbool", dest="merge", default=True)
		self.OptionParser.add_option("--dropstyle", type="inkbool", dest="dropstyle", default=False)

	def effect(self):
		new_options = parse_options(self.options.options)

		for id, node in self.selected.iteritems():
			o = dict()
			if len(self.options.role) > 0 and self.options.role != '_none_':
				node.set(therion_role, self.options.role)
			if len(self.options.type) > 0:
				node.set(therion_type, self.options.type)
				if self.options.type == 'section':
					o['direction'] = 'begin'
			if self.options.merge:
				o.update(parse_options(node.get(therion_options, '')))
			o.update(new_options)
			node.set(therion_options, format_options(o))

			if node.tag == svg_use:
				type = node.get(therion_type, '_none_').split(':')[0]
				href = node.get(therion_role, '_none_') + '-' + type
				if href in self.doc_ids:
					node.set(xlink_href, '#' + href)

			elif node.tag == svg_path and node.get(therion_role, 'line') == 'line':
				type = node.get(therion_type, '_none_').split(':')[0]
				node.set('class', 'line ' + type)
				if self.options.dropstyle:
					node.set('style', '')
				href = 'LPE-' + type
				if href in self.doc_ids:
					node.set(inkscape_path_effect, '#' + href)
					if not node.attrib.has_key(inkscape_original_d):
						node.set(inkscape_original_d, node.get('d'))

e = Th2SetProps()
e.affect()

